/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LibLinear.xs. Do not edit this file, edit LibLinear.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Algorithm/LibLinear.xs"
#include <algorithm>
#include <cerrno>
#include <cstdlib>
#include <cstring>
#include "linear.h"

#define NO_XSLOCKS
#include "EXTERN.h"
#include "XSUB.h"
#include "perl.h"
#include "ppport.h"

namespace {

struct parameter *
alloc_parameter(pTHX_ int num_weights) {
    struct parameter *parameter_;
    Newx(parameter_, 1, struct parameter);
    if (num_weights == 0) {
        parameter_->weight_label = NULL;
        parameter_->weight = NULL;
    } else {
        Newx(parameter_->weight_label, num_weights, int);
        Newx(parameter_->weight, num_weights, double);
    }
    parameter_->init_sol = NULL;
    parameter_->nr_weight = num_weights;
    return parameter_;
}

struct problem *
alloc_problem(pTHX_ int num_training_data) {
    struct problem *problem_;
    Newx(problem_, 1, struct problem);
    Newx(problem_->y, num_training_data, double);
    // Assuming that internal representation of null pointer is zero.
    Newxz(problem_->x, num_training_data, struct feature_node *);
    problem_->l = num_training_data;
    return problem_;
}

void
dummy_puts(const char *) {}

int
find_max_feature_index(pTHX_ AV *features) {
    int num_features = av_len(features) + 1;
    int max_feature_index = 0;
    for (int i = 0; i < num_features; ++i) {
        SV *feature = *av_fetch(features, i, 0);
        if (!(SvROK(feature) && SvTYPE(SvRV(feature)) == SVt_PVHV)) {
            Perl_croak(aTHX_ "Not a HASH reference.");
        }
        HV *feature_hash = (HV *)SvRV(feature);
        hv_iterinit(feature_hash);
        HE *nonzero_element;
        while ((nonzero_element = hv_iternext(feature_hash))) {
            I32 index_length;
            int index = atoi(hv_iterkey(nonzero_element, &index_length));
            if (max_feature_index < index) { max_feature_index = index; }
        }
    }
    return max_feature_index;
}

void
free_parameter(pTHX_ struct parameter *parameter_) {
    Safefree(parameter_->weight_label);
    Safefree(parameter_->weight);
    Safefree(parameter_);
}

void
free_problem(pTHX_ struct problem *problem_) {
    for (int i = 0; i < problem_->l; ++i) {
        struct feature_node *feature_vector = problem_->x[i];
        if (feature_vector) { Safefree(feature_vector); }
    }
    Safefree(problem_->x);
    Safefree(problem_->y);
    Safefree(problem_);
}

bool
has_less_index(const struct feature_node& a, const struct feature_node& b) {
    return a.index < b.index;
}

struct feature_node *
hv2feature(
    pTHX_ HV *feature_hash, int bias_index = 0, double bias = -1.0) {
    bool has_bias = bias >= 0;
    int feature_vector_size =
        hv_iterinit(feature_hash) + (has_bias ? 1 : 0) + 1;
    struct feature_node *feature_vector;
    Newx(feature_vector, feature_vector_size, struct feature_node);
    char *index;
    I32 index_length;
    SV *value;
    struct feature_node *curr = feature_vector;
    while ((value = hv_iternextsv(feature_hash, &index, &index_length))) {
        curr->index = atoi(index);
        curr->value = SvNV(value);
        ++curr;
    }
    if (has_bias) {
        curr->index = bias_index;
        curr->value = bias;
        ++curr;
    }
    // Sentinel. LIBLINEAR doesn't care about its value.
    curr->index = -1;
    // Since LIBLINEAR 2.40, |sparse_operator::sparse_dot|, used in one-class
    // SVM solver (|solve_oneclass_svm|), started to assume that the
    // |feature_node| vector is sorted by |index|.
    std::sort(
        feature_vector,
        // |- 1| for removing sentinel node from the range of sorting.
        feature_vector + feature_vector_size - 1,
        has_less_index);
    return feature_vector;
}

inline bool
is_regression_solver(const struct parameter *parameter_) {
    switch (parameter_->solver_type) {
    case L2R_L2LOSS_SVR:
    case L2R_L2LOSS_SVR_DUAL:
    case L2R_L1LOSS_SVR_DUAL:
        return true;
    default:
        return false;
    }
}

void
validate_parameter(
    pTHX_
    struct problem *problem_,
    struct parameter *parameter_) {
    const char *message = check_parameter(problem_, parameter_);
    if (message) {
        Perl_croak(aTHX_ "Invalid training parameter: %s", message);
    }
}

}  // namespace

#line 159 "lib/Algorithm/LibLinear.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 303 "lib/Algorithm/LibLinear.c"

XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_train); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_train)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "klass, problem_, parameter_");
    {
	struct problem *	problem_;
	struct parameter *	parameter_;
	struct model *	RETVAL;

    if (SvROK(ST(1)) &&
          sv_derived_from(ST(1), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(1)));
        problem_ = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::train",
            "problem_", "struct problemPtr");
    }
;

    if (SvROK(ST(2)) &&
          sv_derived_from(ST(2), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(2)));
        parameter_ = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::train",
            "parameter_", "struct parameterPtr");
    }
;
#line 220 "lib/Algorithm/LibLinear.xs"
    validate_parameter(aTHX_ problem_, parameter_);
    RETVAL = train(problem_, parameter_);
#line 342 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Algorithm::LibLinear::Model::Raw", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_load); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_load)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, filename");
    {
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	struct model *	RETVAL;
#line 229 "lib/Algorithm/LibLinear.xs"
    RETVAL = load_model(filename);
    if (!RETVAL) {
        Perl_croak(aTHX_ "Failed to load a model from file: %s.", filename);
    }
#line 369 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Algorithm::LibLinear::Model::Raw", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_bias); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_bias)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, label");
    {
	struct model *	self;
	int	label = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::bias",
            "self", "struct modelPtr");
    }
;
#line 241 "lib/Algorithm/LibLinear.xs"
    RETVAL = get_decfun_bias(self, label);
#line 407 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_class_labels); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_class_labels)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::class_labels",
            "self", "struct modelPtr");
    }
;
#line 249 "lib/Algorithm/LibLinear.xs"
    RETVAL = newAV();
    av_extend(RETVAL, self->nr_class - 1);
    for (int i = 0; i < self->nr_class; ++i) {
        av_push(RETVAL, newSViv(self->label[i]));
    }
#line 442 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_coefficient); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_coefficient)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, feature, label");
    {
	struct model *	self;
	int	feature = (int)SvIV(ST(1))
;
	int	label = (int)SvIV(ST(2))
;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::coefficient",
            "self", "struct modelPtr");
    }
;
#line 263 "lib/Algorithm/LibLinear.xs"
    RETVAL = get_decfun_coef(self, feature, label);
#line 482 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_is_oneclass_model); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_is_oneclass_model)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model*	self;
	bool	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::is_oneclass_model",
            "self", "struct modelPtr");
    }
;
#line 271 "lib/Algorithm/LibLinear.xs"
    RETVAL = check_oneclass_model(self);
#line 513 "lib/Algorithm/LibLinear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_is_probability_model); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_is_probability_model)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;
	bool	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::is_probability_model",
            "self", "struct modelPtr");
    }
;
#line 279 "lib/Algorithm/LibLinear.xs"
    RETVAL = check_probability_model(self);
#line 543 "lib/Algorithm/LibLinear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_is_regression_model); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_is_regression_model)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;
	bool	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::is_regression_model",
            "self", "struct modelPtr");
    }
;
#line 287 "lib/Algorithm/LibLinear.xs"
    RETVAL = check_regression_model(self);
#line 573 "lib/Algorithm/LibLinear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_num_classes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_num_classes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;
	int	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::num_classes",
            "self", "struct modelPtr");
    }
;
#line 295 "lib/Algorithm/LibLinear.xs"
    RETVAL = get_nr_class(self);
#line 604 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_num_features); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_num_features)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;
	int	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::num_features",
            "self", "struct modelPtr");
    }
;
#line 303 "lib/Algorithm/LibLinear.xs"
    RETVAL = get_nr_feature(self);
#line 636 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_predict); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_predict)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, feature_hash");
    {
	struct model *	self;
	HV *	feature_hash;
	SV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::predict",
            "self", "struct modelPtr");
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    feature_hash = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Algorithm::LibLinear::Model::Raw::predict",
				"feature_hash");
		}
	} STMT_END
;
#line 312 "lib/Algorithm/LibLinear.xs"
    struct feature_node *feature_vector = hv2feature(aTHX_ feature_hash);
    double prediction = predict(self, feature_vector);
    Safefree(feature_vector);
    RETVAL = is_regression_solver(&self->param) ?
      newSVnv(prediction) : newSViv((int)prediction);
#line 686 "lib/Algorithm/LibLinear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_predict_probability); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_predict_probability)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, feature_hash");
    {
	struct model *	self;
	HV *	feature_hash;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::predict_probability",
            "self", "struct modelPtr");
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    feature_hash = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Algorithm::LibLinear::Model::Raw::predict_probability",
				"feature_hash");
		}
	} STMT_END
;
#line 325 "lib/Algorithm/LibLinear.xs"
    RETVAL = newAV();
    if (check_probability_model(self)) {
        struct feature_node *feature_vector = hv2feature(aTHX_ feature_hash);
        double *estimated_probabilities;
        int num_classes = get_nr_class(self);
        Newx(estimated_probabilities, num_classes, double);
        predict_probability(self, feature_vector, estimated_probabilities);
        av_extend(RETVAL, num_classes - 1);
        for (int i = 0; i < num_classes; ++i) {
            av_push(RETVAL, newSVnv(estimated_probabilities[i]));
        }
        Safefree(feature_vector);
        Safefree(estimated_probabilities);
    }
#line 745 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_predict_values); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_predict_values)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, feature_hash");
    {
	struct model *	self;
	HV *	feature_hash;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::predict_values",
            "self", "struct modelPtr");
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    feature_hash = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Algorithm::LibLinear::Model::Raw::predict_values",
				"feature_hash");
		}
	} STMT_END
;
#line 347 "lib/Algorithm/LibLinear.xs"
    struct feature_node *feature_vector = hv2feature(aTHX_ feature_hash);
    int num_classes = get_nr_class(self);
    int num_decision_values =
        (num_classes == 2 && self->param.solver_type != MCSVM_CS) ?
        1 : num_classes;
    double *decision_values;
    Newx(decision_values, num_decision_values, double);
    predict_values(self, feature_vector, decision_values);
    RETVAL = newAV();
    av_extend(RETVAL, num_decision_values - 1);
    for (int i = 0; i < num_decision_values; ++i) {
        av_push(RETVAL, newSVnv(decision_values[i]));
    }
    Safefree(decision_values);
    Safefree(feature_vector);
#line 809 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_rho); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_rho)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::rho",
            "self", "struct modelPtr");
    }
;
#line 369 "lib/Algorithm/LibLinear.xs"
    RETVAL = get_decfun_rho(self);
#line 845 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_save)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct model *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::save",
            "self", "struct modelPtr");
    }
;
#line 378 "lib/Algorithm/LibLinear.xs"
    if (save_model(filename, self) != 0) {
        Perl_croak(
          aTHX_
          "Error occured during save process: %s",
          errno == 0 ? "unknown error" : strerror(errno)
        );
    }
#line 883 "lib/Algorithm/LibLinear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Model__Raw_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct model *	self;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Model::Raw")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct model *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Model::Raw::DESTROY",
            "self", "struct modelPtr");
    }
;
#line 390 "lib/Algorithm/LibLinear.xs"
    free_and_destroy_model(&self);
#line 911 "lib/Algorithm/LibLinear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_new)
{
    dVAR; dXSARGS;
    if (items != 9)
       croak_xs_usage(cv,  "klass, solver_type, epsilon, cost, weight_labels, weights, loss_sensitivity, nu, regularize_bias");
    {
	int	solver_type = (int)SvIV(ST(1))
;
	double	epsilon = (double)SvNV(ST(2))
;
	double	cost = (double)SvNV(ST(3))
;
	AV *	weight_labels;
	AV *	weights;
	double	loss_sensitivity = (double)SvNV(ST(6))
;
	double	nu = (double)SvNV(ST(7))
;
	bool	regularize_bias = (bool)SvTRUE(ST(8))
;
	struct parameter *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(4);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    weight_labels = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Algorithm::LibLinear::TrainingParameter::new",
				"weight_labels");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(5);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    weights = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Algorithm::LibLinear::TrainingParameter::new",
				"weights");
		}
	} STMT_END
;
#line 407 "lib/Algorithm/LibLinear.xs"
    int num_weights = av_len(weight_labels) + 1;
    if (av_len(weights) + 1 != num_weights) {
        Perl_croak(
          aTHX_
          "The number of weight labels is not equal to the number of"
          " weights.");
    }
    // |init_sol| is initialized within |alloc_parameter|.
    RETVAL = alloc_parameter(aTHX_ num_weights);
    RETVAL->solver_type = solver_type;
    RETVAL->eps = epsilon;
    RETVAL->C = cost;
    RETVAL->p = loss_sensitivity;
    RETVAL->nu = nu;
    RETVAL->regularize_bias = regularize_bias ? 1 : 0;
    dXCPT;
    XCPT_TRY_START {
        int *weight_labels_ = RETVAL->weight_label;
        double *weights_ = RETVAL->weight;
        for (int i = 0; i < num_weights; ++i) {
            weight_labels_[i] = SvIV(*av_fetch(weight_labels, i, 0));
            weights_[i] = SvNV(*av_fetch(weights, i, 0));
        }
    } XCPT_TRY_END
    XCPT_CATCH {
        free_parameter(aTHX_ RETVAL);
        XCPT_RETHROW;
    }
#line 996 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(
	    RETVALSV, "Algorithm::LibLinear::TrainingParameter", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_cross_validation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_cross_validation)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, problem_, num_folds");
    {
	struct parameter *	self;
	struct problem *	problem_;
	int	num_folds = (int)SvIV(ST(2))
;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::cross_validation",
            "self", "struct parameterPtr");
    }
;

    if (SvROK(ST(1)) &&
          sv_derived_from(ST(1), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(1)));
        problem_ = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::cross_validation",
            "problem_", "struct problemPtr");
    }
;
#line 444 "lib/Algorithm/LibLinear.xs"
    validate_parameter(aTHX_ problem_, self);
    double *targets;
    Newx(targets, problem_->l, double);
    cross_validation(problem_, self, num_folds, targets);
    RETVAL = newAV();
    av_extend(RETVAL, problem_->l - 1);
    for (int i = 0; i < problem_->l; ++i) {
        av_push(RETVAL, newSVnv(targets[i]));
    }
    Safefree(targets);
#line 1056 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_find_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_find_parameters)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "self, problem_, num_folds, initial_C, initial_p, update");
    {
	struct parameter *	self;
	struct problem *	problem_;
	int	num_folds = (int)SvIV(ST(2))
;
	double	initial_C = (double)SvNV(ST(3))
;
	double	initial_p = (double)SvNV(ST(4))
;
	bool	update = (bool)SvTRUE(ST(5))
;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::find_parameters",
            "self", "struct parameterPtr");
    }
;

    if (SvROK(ST(1)) &&
          sv_derived_from(ST(1), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(1)));
        problem_ = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::find_parameters",
            "problem_", "struct problemPtr");
    }
;
#line 466 "lib/Algorithm/LibLinear.xs"
    double best_C, best_p, accuracy;
    find_parameters(
        problem_, self, num_folds, initial_C, initial_p, &best_C, &best_p,
        &accuracy);
    // LIBLINEAR 2.0 resets default printer function during call of
    // find_parameter_C(). So disable it again.
    set_print_string_function(dummy_puts);
    bool is_regression_model = self->solver_type == L2R_L2LOSS_SVR;
    if (update) {
        self->C = best_C;
        if (is_regression_model) {
          self->p = best_p;
        }
    }
    RETVAL = newAV();
    av_push(RETVAL, newSVnv(best_C));
    av_push(
        RETVAL,
        is_regression_model ? newSVnv(best_p) : newSVsv(&PL_sv_undef));
    av_push(RETVAL, newSVnv(accuracy));
#line 1131 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_is_regression_solver); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_is_regression_solver)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	bool	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::is_regression_solver",
            "self", "struct parameterPtr");
    }
;
#line 493 "lib/Algorithm/LibLinear.xs"
    RETVAL = is_regression_solver(self);
#line 1166 "lib/Algorithm/LibLinear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_cost); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_cost)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::cost",
            "self", "struct parameterPtr");
    }
;
#line 501 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->C;
#line 1197 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_epsilon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_epsilon)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::epsilon",
            "self", "struct parameterPtr");
    }
;
#line 509 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->eps;
#line 1229 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_loss_sensitivity); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_loss_sensitivity)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::loss_sensitivity",
            "self", "struct parameterPtr");
    }
;
#line 517 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->p;
#line 1261 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_solver_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_solver_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	int	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::solver_type",
            "self", "struct parameterPtr");
    }
;
#line 525 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->solver_type;
#line 1293 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_weights); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_weights)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::weights",
            "self", "struct parameterPtr");
    }
;
#line 533 "lib/Algorithm/LibLinear.xs"
    RETVAL = newAV();
    av_extend(RETVAL, self->nr_weight - 1);
    for (int i = 0; i < self->nr_weight; ++i) {
        av_push(RETVAL, newSVnv(self->weight[i]));
    }
#line 1328 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_weight_labels); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_weight_labels)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;
	AV *	RETVAL;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::weight_labels",
            "self", "struct parameterPtr");
    }
;
#line 545 "lib/Algorithm/LibLinear.xs"
    RETVAL = newAV();
    av_extend(RETVAL, self->nr_weight - 1);
    for (int i = 0; i < self->nr_weight; ++i) {
        av_push(RETVAL, newSViv(self->weight_label[i]));
    }
#line 1367 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV_noinc((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__TrainingParameter_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct parameter *	self;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::TrainingParameter")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct parameter *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::TrainingParameter::DESTROY",
            "self", "struct parameterPtr");
    }
;
#line 557 "lib/Algorithm/LibLinear.xs"
    free_parameter(aTHX_ self);
#line 1401 "lib/Algorithm/LibLinear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__LibLinear__Problem_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Problem_new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "klass, labels, features, bias");
    {
	AV *	labels;
	AV *	features;
	double	bias = (double)SvNV(ST(3))
;
	struct problem *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    labels = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Algorithm::LibLinear::Problem::new",
				"labels");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    features = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Algorithm::LibLinear::Problem::new",
				"features");
		}
	} STMT_END
;
#line 569 "lib/Algorithm/LibLinear.xs"
    int num_training_data = av_len(labels) + 1;
    if (num_training_data == 0) {
        Perl_croak(aTHX_ "No training set is given.");
    }
    if (av_len(features) + 1 != num_training_data) {
        Perl_croak(
            aTHX_
            "The number of labels is not equal to the number of features.");
    }

    RETVAL = alloc_problem(aTHX_ num_training_data);
    bool has_bias = bias >= 0;
    dXCPT;
    XCPT_TRY_START {
        double *labels_ = RETVAL->y;
        for (int i = 0; i < num_training_data; ++i) {
            SV *label = *av_fetch(labels, i, 0);
            labels_[i] = SvIV(label);
        }

        struct feature_node **features_ = RETVAL->x;
        int max_feature_index =
            find_max_feature_index(aTHX_ features) + (has_bias ? 1 : 0);
        for (int i = 0; i < num_training_data; ++i) {
            SV *feature = *av_fetch(features, i, 0);
            if (!(SvROK(feature) && SvTYPE(SvRV(feature)) == SVt_PVHV)) {
                Perl_croak(aTHX_ "Not a HASH reference.");
            }
            HV *feature_hash = (HV *)SvRV(feature);
            features_[i] =
                hv2feature(aTHX_ feature_hash, max_feature_index, bias);
        }
        RETVAL->bias = bias;
        RETVAL->n = max_feature_index;
    } XCPT_TRY_END
    XCPT_CATCH {
        free_problem(aTHX_ RETVAL);
        XCPT_RETHROW;
    }
#line 1487 "lib/Algorithm/LibLinear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Algorithm::LibLinear::Problem", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Problem_bias); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Problem_bias)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct problem *	self;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Problem::bias",
            "self", "struct problemPtr");
    }
;
#line 615 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->bias;
#line 1523 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Problem_data_set_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Problem_data_set_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct problem *	self;
	int	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Problem::data_set_size",
            "self", "struct problemPtr");
    }
;
#line 623 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->l;
#line 1555 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Problem_num_features); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Problem_num_features)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct problem *	self;
	int	RETVAL;
	dXSTARG;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Problem::num_features",
            "self", "struct problemPtr");
    }
;
#line 631 "lib/Algorithm/LibLinear.xs"
    RETVAL = self->n;
#line 1587 "lib/Algorithm/LibLinear.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__LibLinear__Problem_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__LibLinear__Problem_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct problem *	self;

    if (SvROK(ST(0)) &&
          sv_derived_from(ST(0), "Algorithm::LibLinear::Problem")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(struct problem *,tmp);
    }
    else {
        Perl_croak(aTHX_ "%s: %s is not of type %s",
            "Algorithm::LibLinear::Problem::DESTROY",
            "self", "struct problemPtr");
    }
;
#line 639 "lib/Algorithm/LibLinear.xs"
    free_problem(aTHX_ self);
#line 1617 "lib/Algorithm/LibLinear.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Algorithm__LibLinear); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Algorithm__LibLinear)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Algorithm::LibLinear::Model::Raw::train", XS_Algorithm__LibLinear__Model__Raw_train);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::load", XS_Algorithm__LibLinear__Model__Raw_load);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::bias", XS_Algorithm__LibLinear__Model__Raw_bias);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::class_labels", XS_Algorithm__LibLinear__Model__Raw_class_labels);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::coefficient", XS_Algorithm__LibLinear__Model__Raw_coefficient);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::is_oneclass_model", XS_Algorithm__LibLinear__Model__Raw_is_oneclass_model);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::is_probability_model", XS_Algorithm__LibLinear__Model__Raw_is_probability_model);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::is_regression_model", XS_Algorithm__LibLinear__Model__Raw_is_regression_model);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::num_classes", XS_Algorithm__LibLinear__Model__Raw_num_classes);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::num_features", XS_Algorithm__LibLinear__Model__Raw_num_features);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::predict", XS_Algorithm__LibLinear__Model__Raw_predict);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::predict_probability", XS_Algorithm__LibLinear__Model__Raw_predict_probability);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::predict_values", XS_Algorithm__LibLinear__Model__Raw_predict_values);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::rho", XS_Algorithm__LibLinear__Model__Raw_rho);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::save", XS_Algorithm__LibLinear__Model__Raw_save);
        newXS_deffile("Algorithm::LibLinear::Model::Raw::DESTROY", XS_Algorithm__LibLinear__Model__Raw_DESTROY);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::new", XS_Algorithm__LibLinear__TrainingParameter_new);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::cross_validation", XS_Algorithm__LibLinear__TrainingParameter_cross_validation);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::find_parameters", XS_Algorithm__LibLinear__TrainingParameter_find_parameters);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::is_regression_solver", XS_Algorithm__LibLinear__TrainingParameter_is_regression_solver);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::cost", XS_Algorithm__LibLinear__TrainingParameter_cost);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::epsilon", XS_Algorithm__LibLinear__TrainingParameter_epsilon);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::loss_sensitivity", XS_Algorithm__LibLinear__TrainingParameter_loss_sensitivity);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::solver_type", XS_Algorithm__LibLinear__TrainingParameter_solver_type);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::weights", XS_Algorithm__LibLinear__TrainingParameter_weights);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::weight_labels", XS_Algorithm__LibLinear__TrainingParameter_weight_labels);
        newXS_deffile("Algorithm::LibLinear::TrainingParameter::DESTROY", XS_Algorithm__LibLinear__TrainingParameter_DESTROY);
        newXS_deffile("Algorithm::LibLinear::Problem::new", XS_Algorithm__LibLinear__Problem_new);
        newXS_deffile("Algorithm::LibLinear::Problem::bias", XS_Algorithm__LibLinear__Problem_bias);
        newXS_deffile("Algorithm::LibLinear::Problem::data_set_size", XS_Algorithm__LibLinear__Problem_data_set_size);
        newXS_deffile("Algorithm::LibLinear::Problem::num_features", XS_Algorithm__LibLinear__Problem_num_features);
        newXS_deffile("Algorithm::LibLinear::Problem::DESTROY", XS_Algorithm__LibLinear__Problem_DESTROY);

    /* Initialisation Section */

#line 211 "lib/Algorithm/LibLinear.xs"
    set_print_string_function(dummy_puts);

#line 1688 "lib/Algorithm/LibLinear.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
